#!/usr/bin/env python3
import hashlib
import base64
from Cryptodome.Cipher import AES  
import argparse
import sys
import re


def parse(conf):
    regex = r"Name=\"(.*?)\".*?Username=\"(.*?)\".*?Password=\"(.*?)\".*?Hostname=\"(.*?)\".*?Protocol=\"(.*?)\""

    with open(conf,"r") as f:
        a =f.read()

    matches = re.finditer(regex, a, re.MULTILINE)

    for matchNum, match in enumerate(matches, start=1):
        m = match.groups()
        print("Name: {}\nUsername: {}\nPassword: {}\nHostname: {}\nProtocol: {}\n".format(m[0],m[1],uncipher(m[2]),m[3],m[4]))


def main():
  parser = argparse.ArgumentParser(description="Decrypt mRemoteNG passwords.")
  group = parser.add_mutually_exclusive_group()
  group.add_argument("-f", "--file", help="name of file containing mRemoteNG password")
  parser.add_argument("-p", "--password", help="Custom password", default="mR3m")

  if len(sys.argv) < 2:
    parser.print_help(sys.stderr)
    sys.exit(1)

  args = parser.parse_args()
  encrypted_data = ""
  if args.file != None:
    parse(args.file)

def uncipher(encrypted_data):
  if encrypted_data == "":
      return ""
  encrypted_data = base64.b64decode(encrypted_data)
  salt = encrypted_data[:16]
  associated_data = encrypted_data[:16]
  nonce = encrypted_data[16:32]
  ciphertext = encrypted_data[32:-16]
  tag = encrypted_data[-16:]
  key = hashlib.pbkdf2_hmac("sha1", "mR3m".encode(), salt, 1000, dklen=32)
  cipher = AES.new(key, AES.MODE_GCM, nonce=nonce)
  cipher.update(associated_data)
  plaintext = cipher.decrypt_and_verify(ciphertext, tag)
  return(plaintext.decode("utf-8"))

if __name__ == "__main__":
  main() 
